SystemOrganization addCategory: 'JASVGI'!

Object subclass: #JASVGIObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIObject commentStamp: '' prior: 0!
Just 
Another 
SVG
Interface!

JASVGIObject subclass: #JASVGIAttribute
	instanceVariableNames: 'svgTagElement attributeName attributeValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
fill: colorValue

	^self name: 'fill' value: colorValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
height: height

	^self name: 'height' value: height printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:13'!
parent: aJasvgiTagElement name: stringName value: stringValue

	^super new initialize
		svgTagElement: aJasvgiTagElement; 
		attributeName: stringName;
		attributeValue: stringValue;
		yourself! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
rx: rx

	^self name: 'rx' value: rx printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
ry: ry

	^self name: 'ry' value: ry printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
stroke: strokeValue

	^self name: 'stroke' value: strokeValue! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
width: width

	^self name: 'width' value: width printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
x: xValue

	^self name: 'x' value: xValue printString! !

!JASVGIAttribute class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
y: yValue

	^self name: 'y' value: yValue printString! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
asSvgAttribute

	^attributeName -> self getAttributeValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeName
	^attributeName! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeName: newValue
	attributeName := newValue! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeValue
	^attributeValue! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
attributeValue: newValue
	attributeValue := newValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
getAttributeValue

	(attributeValue class == String) ifFalse: [^attributeValue printString].

	^attributeValue! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:13'!
isStyleAttribute

	^svgTagElement styleAttributesNames includes: attributeName! !

!JASVGIAttribute methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:11'!
printOn: aStream

	super printOn: aStream.

	aStream nextPutAll: ('(', attributeName, ' > ', self getAttributeValue,')')! !

!JASVGIAttribute methodsFor: 'Accessing' stamp: 'BrunoBB 09/07/2016 07:11'!
svgTagElement
	^svgTagElement! !

!JASVGIAttribute methodsFor: 'Updating' stamp: 'BrunoBB 09/07/2016 07:11'!
svgTagElement: newValue
	svgTagElement := newValue! !

JASVGIObject subclass: #JASVGICanvas
	instanceVariableNames: 'xmlCanvas svgTag svgObjects svgMarkers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGICanvas subclass: #JASVGIBpmCanvas
	instanceVariableNames: 'namesAndTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 06:38'!
example1
	| jasv line |

	jasv := JASVGIBpmCanvas newWidth: '400px' height: '400px'.
	jasv addMarker: 
		(JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 200@30.
	jasv drawActivityNamed: 'Task 2' at: 60@90.
	jasv drawEndNamed: 'end' at: 300@300.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.

	jasv contents.! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 07:05'!
example2
	| jasv line |

	jasv := JASVGIBpmCanvas newWidth: '500px' height: '400px'.
	jasv addMarker: 
		(JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 80@30.
	jasv drawGatewayAt: 250@45 id: 'g1'.
	jasv drawActivityNamed: 'Task 2' at: 320@30.
	jasv drawActivityNamed: 'Task 3' at: 100@150.
	jasv drawEndNamed: 'end' at: 290@180.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'g1').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 3').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 3') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	jasv contents.! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 06:06'!
connect: figureOne to: figureTwo

	^self drawLineM: 
		(Array 
				with: (figureOne getPointToConnectTo: figureTwo)
				with: (figureTwo getPointToConnectTo: figureOne))! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:03'!
defaultEndEventFillColor

	^'red'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defaultEventHeight

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:43'!
defaultEventWidth

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:42'!
defaultGatewayFillColor

	^'lightgray'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayHeight

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayWidth

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defaultStartEventFillColor

	^'white'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskFillColor

	^'lightsteelblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:02'!
defaultTaskHeight

	^60! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskWidth

	^120! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:04'!
defultEndEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defultStartEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 05:53'!
drawActivityNamed: aString at: aPoint
	| rect textPoint |

	rect := self drawRoundRectangleAt: aPoint 
						height: self defaultTaskHeight 
						width: self defaultTaskWidth 
						fillColor: self defaultTaskFillColor 
						stroke: self defaultTaskStroke.

	textPoint := (aPoint x + (self defaultTaskWidth // 3)) @ (aPoint y + (self defaultTaskHeight // 2)).

	self drawText: aString at: textPoint.

	namesAndTags at: aString put: rect "map the Activity name with the Activity id"! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 06:31'!
drawEndNamed: aString at: aPoint
	| start textPoint |

	start := self drawCircleAt: aPoint r: 20 fillColor: self defaultEndEventFillColor stroke: self defultEndEventStroke strokeWidth: '3'.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	self drawText: aString at: start position.

	namesAndTags at: aString put: start "map the Activity name with the Activity id"! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 06:45'!
drawGatewayAt: aPoint id: id

	^self drawGatewayAt: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: self defaultGatewayFillColor
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 06:54'!
drawGatewayAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| figure rotation |

	figure := JASVGITagRectangle newAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke.

	rotation := 'rotate(-45 ', figure center x printString, ' ', figure center y printString, ')'.
	figure transform: rotation.

	namesAndTags at: id put: figure. "map the Gateway name with the Gateway id"

	^self draw: figure! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 06:01'!
drawStartNamed: aString at: aPoint
	| start textPoint |

	start := self drawCircleAt: aPoint r: 20 fillColor: self defaultStartEventFillColor stroke: self defultStartEventStroke.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	self drawText: aString at: start position.

	namesAndTags at: aString put: start "map the Activity name with the Activity id"! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/06/2016 10:26'!
getJasvgiTagNamed: aString

	^self getJasvgiTagNamed: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'bpm figure' stamp: 'BrunoBB 09/10/2016 05:54'!
getJasvgiTagNamed: aString ifAbsent: aBlock

	^namesAndTags at: aString ifAbsent: aBlock! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:21'!
initialize

	super initialize.

	namesAndTags := Dictionary new.! !

!JASVGIBpmCanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags
	^namesAndTags! !

!JASVGIBpmCanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags: newValue
	namesAndTags := newValue! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:29'!
defaultHeaders

	^OrderedCollection new 
		add: ('xmlns' -> 'http://www.w3.org/2000/svg');
		add: ('xmlns:xlink' -> 'http://www.w3.org/1999/xlink');
		add: ('width' -> '200px');
		add: ('height' -> '200px');
		yourself! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 05:44'!
example1
	| jasv line |
	jasv := JASVGIBpmCanvas newWidth: '400px' height: '400px'.
	jasv addMarker: 
		(JASVGITagMarker newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawRoundRectangleAt: 300@180 id: 'rect1' height: 60 width: 90 fillColor: 'green' stroke: 'red'.
	(jasv drawGatewayAt: 10@100 id: 'rect2' height: 40 width: 40 fillColor: 'lightblue' stroke: 'black').
	jasv drawRoundRectangleAt: 30@200 id: 'rect3' height: 60 width: 90 fillColor: 'red' stroke: 'blue'.

	line := jasv connect: (jasv getSvgObjectId: 'rect1') to:  (jasv getSvgObjectId: 'rect2').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getSvgObjectId: 'rect3') to:  (jasv getSvgObjectId: 'rect2').
	line setMarkerEnd: 'arrow'.
	jasv contents.! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:31'!
new

	^super new initialize setDefaultCanvas! !

!JASVGICanvas class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:32'!
newWidth: width height: height

	^super new 
		initialize 
		setCanvasWith: (self defaultHeaders add: ('width' -> width); add: ('height' -> height); yourself);
		yourself! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 08:10'!
addMarker: tagMarker

	^svgMarkers at: tagMarker id put: tagMarker! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/09/2016 10:19'!
connect: figureOne to: figureTwo

	^self drawLineM: 
		(Array 
				with: (figureOne getPointToConnectTo: figureTwo)
				with: (figureTwo getPointToConnectTo: figureOne))! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 08:09'!
contents
	
	svgTag with: [
		self tag: 'defs' with: [svgMarkers do: [:each | each drawOn: self]].
		(svgObjects orderedKeys select: [:e | e notNil]) do:[:key | | svgFigureTag figureName |
			svgFigureTag := svgObjects at: key.
			figureName := (key subStrings: '.') first.
			svgFigureTag drawOn: self.
		].
	].

	^xmlCanvas contents! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:29'!
defaultHeaders

	^self class defaultHeaders! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 09:42'!
draw: aJASVGITagFigure

	^svgObjects at: aJASVGITagFigure id put: aJASVGITagFigure! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 07:25'!
drawCircleAt: aPoint id: id r: radius fillColor: fillColor stroke: stroke strokeWidth: strokeWidth

	^self draw: (JASVGITagCircle 
						newAt: aPoint 
						id: id 
						r: radius
						fillColor: fillColor 
						stroke: stroke 
						strokeWidth: strokeWidth)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/10/2016 06:32'!
drawCircleAt: aPoint r: radius fillColor: fillColor stroke: stroke

	^self drawCircleAt: aPoint id: UUID new asString r: radius fillColor: fillColor stroke: stroke strokeWidth: '1'! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 07:26'!
drawCircleAt: aPoint r: radius fillColor: fillColor stroke: stroke strokeWidth: strokeWidth

	^self drawCircleAt: aPoint id: UUID new asString r: radius fillColor: fillColor stroke: stroke strokeWidth: strokeWidth! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/09/2016 05:19'!
drawConnectorFrom: initialPoint to: endPoint

	^self draw: (JASVGITagConnector from: initialPoint to: endPoint)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/09/2016 05:21'!
drawConnectorFromId: initialId toId: endId

	^self draw: (JASVGITagConnector fromId: initialId toId: endId)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/09/2016 05:26'!
drawConnectorFromId: initialId toId: endId id: id

	^self draw: (JASVGITagConnector fromId: initialId toId: endId id: id)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 10:09'!
drawEllipseAt: aPoint id: id rx: rx ry: ry fillColor: fillColor stroke: stroke strokeWidth: strokeWidth

	^self draw: (JASVGITagEllipse
						newAt: aPoint 
						id: id 
						rx: rx 
						ry: ry 
						fillColor: fillColor 
						stroke: stroke 
						strokeWidth: strokeWidth)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 08:50'!
drawLineM: points

	^self drawLineM: points id: UUID new asString! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 08:50'!
drawLineM: points id: id

	^self draw: (JASVGITagPath newLineM: points id: id)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawRectangleAt: aPoint height: height width: width fillColor: fillColor stroke: stroke

	^self drawRectangleAt: aPoint id: UUID new asString height: height width: width fillColor: fillColor stroke: stroke! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 06:59'!
drawRectangleAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke

	^self draw: (JASVGITagRectangle 
						newAt: aPoint 
						id: id height: height 
						width: width 
						fillColor: fillColor 
						stroke: stroke)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawRoundRectangleAt: aPoint height: height width: width fillColor: fillColor stroke: stroke

	^self drawRoundRectangleAt: aPoint id: UUID new asString height: height width: width fillColor: fillColor stroke: stroke! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 07:00'!
drawRoundRectangleAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke

	^self draw: (JASVGITagRectangle 
						newRoundAt: aPoint 
						id: id height: height 
						width: width 
						fillColor: fillColor 
						stroke: stroke)! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/06/2016 11:11'!
drawText: aString at: aPoint 

	^self drawText: aString at: aPoint id: UUID new asString! !

!JASVGICanvas methodsFor: 'figures' stamp: 'BrunoBB 09/07/2016 07:04'!
drawText: aString at: aPoint id: id 

	^self draw: (JASVGITagText newText: aString at: aPoint id: id)! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:34'!
getSvgObjectId: id

	^svgObjects at: id ifAbsent: [nil]! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:28'!
initialize

	super initialize.

	xmlCanvas := XMLWriter new.
	svgObjects := OrderPreservingDictionary new.
	svgMarkers := OrderPreservingDictionary new.! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:27'!
setCanvasWith: headers

	svgTag := self tag: 'svg' attributes: headers.! !

!JASVGICanvas methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:30'!
setDefaultCanvas

	svgTag := self tag: 'svg' attributes: self defaultHeaders.! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:12'!
svgMarkers
	^svgMarkers! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:12'!
svgMarkers: newValue
	svgMarkers := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
svgObjects
	^svgObjects! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
svgObjects: newValue
	svgObjects := newValue! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
svgTag
	^svgTag! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
svgTag: newValue
	svgTag := newValue! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 14:02'!
tag: tagName attributes: aCollection

	^xmlCanvas tag: tagName attributes: aCollection! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 08:08'!
tag: tagName attributes: aCollection with: textOrBlock

	^xmlCanvas tag: tagName attributes: aCollection with: textOrBlock! !

!JASVGICanvas methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 08:08'!
tag: tagName with: textOrBlock

	^xmlCanvas tag: tagName with: textOrBlock! !

!JASVGICanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:11'!
xmlCanvas
	^xmlCanvas! !

!JASVGICanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:11'!
xmlCanvas: newValue
	xmlCanvas := newValue! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 07:28'!
new

	^super new initialize! !

!JASVGIObject class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 09:20'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width')! !

JASVGIObject subclass: #JASVGITagElement
	instanceVariableNames: 'id attributes subTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagElement subclass: #JASVGITagConnector
	instanceVariableNames: 'startPoint endPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:12'!
from: startPoint to: endPoint

	^super new initialize
		startPoint: startPoint endPoint: endPoint;
		yourself! !

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:20'!
fromId: startId toId: endId

	^super new initialize
		startId: startId endId: endId;
		yourself! !

!JASVGITagConnector class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:23'!
fromId: startId toId: endId id: id

	^super new initialize
		id: id;
		startId: startId endId: endId;
		yourself! !

!JASVGITagConnector methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 05:10'!
endPoint
	^endPoint! !

!JASVGITagConnector methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 05:10'!
endPoint: newValue
	endPoint := newValue! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:20'!
startId: startId endId: endId
	| attributesCollection pointsStream |

	pointsStream := PrintStream on: String new.
	pointsStream nextPutAll: 'url(#', startId, '),'.
	pointsStream nextPutAll: 'url(#', endId, ')'.
	
	attributesCollection := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'points' value: pointsStream contents);
		yourself.

	self setAttributes: attributesCollection.! !

!JASVGITagConnector methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 05:10'!
startPoint
	^startPoint! !

!JASVGITagConnector methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 05:10'!
startPoint: newValue
	startPoint := newValue! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:21'!
startPoint: startPointTag endPoint: endPointTag

	^self startId: startPointTag id endId: endPointTag id! !

!JASVGITagConnector methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:10'!
svgTag

	^'connector'! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 06:58'!
newId: id withAll: anOrderedCollection

	^super new initialize
		id: id;
		setAttributes: anOrderedCollection;
		yourself! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:15'!
styleAttributesNames

	^#()! !

!JASVGITagElement class methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:17'!
withAll: anOrderedCollection

	^super new initialize
		setAttributes: anOrderedCollection;
		yourself! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:46'!
add: aJASVGIAttribute

	^attributes at: aJASVGIAttribute attributeName put: aJASVGIAttribute! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
addAll: aCollection

	^attributes addAll: aCollection! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
addSubTag: aJASVGITag

	^subTags at: aJASVGITag id put: aJASVGITag! !

!JASVGITagElement methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 11:08'!
asSvgAttributes
	| svgAttributes styles |

	svgAttributes := OrderedCollection new.
	styles := PrintStream on: String new.

	attributes do: [:each | 
		each isStyleAttribute
		ifTrue: [styles nextPutAll: (each attributeName, ': ', each attributeValue,';')] 
		ifFalse: [svgAttributes add: each asSvgAttribute]].

	svgAttributes 
		add: ('id' -> id);
		add: ('style' -> styles contents).

	^svgAttributes! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:03'!
attributes
	^attributes! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:03'!
attributes: newValue
	attributes := newValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 15:20'!
center

	^(self x + (self width // 2)) @ (self y + (self height //2))! !

!JASVGITagElement methodsFor: 'draw' stamp: 'BrunoBB 09/06/2016 15:30'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self svgTag attributes: self asSvgAttributes! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 09:34'!
getAttributeNamed: aString

	^attributes detect: [:each | each attributeName = aString] ifNone: [nil]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:19'!
getStyleAttribute

	^attributes detect: [:each | each svgTag = 'style'] ifNone: [nil]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 11:03'!
hasSubTags

	^subTags notEmpty! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:41'!
height
	^(self getAttributeNamed: 'height') attributeValue! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:07'!
id
	^id! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:07'!
id: newValue
	id := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:15'!
initialize

	super initialize.

	attributes := Dictionary new.
	subTags := Dictionary new.! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:35'!
position

	^(self x) @ (self y)! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:16'!
setAttributes: aCollection

	aCollection do: [:each | attributes at: each attributeName put: each]! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 04:46'!
setMarker: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:32'!
setMarkerEnd: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker-end' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:32'!
setMarkerStart: markerId

	self add: (JASVGIAttribute 
						parent: self 
						name: 'marker-start' 
						value: 'url(#', markerId, ')'
				)! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:14'!
styleAttributesNames

	^self class styleAttributesNames! !

!JASVGITagElement methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 11:03'!
subTags
	^subTags! !

!JASVGITagElement methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 11:03'!
subTags: newValue
	subTags := newValue! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:30'!
svgTag

	^self subclassResponsibility! !

!JASVGITagElement methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 15:06'!
transform: transformationString

	^self add: (JASVGIAttribute parent: self name: 'transform' value: transformationString)! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
width
	^(self getAttributeNamed: 'width') attributeValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
x
	^(self getAttributeNamed: 'x') attributeValue! !

!JASVGITagElement methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:40'!
y
	^(self getAttributeNamed: 'y') attributeValue! !

JASVGITagElement subclass: #JASVGITagFigure
	instanceVariableNames: 'connectorPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

JASVGITagFigure subclass: #JASVGITagCircle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagCircle class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:30'!
newAsConnectorAt: aPoint 

	^self newAt: aPoint 
			id: UUID new asString
			r: 5 
			fillColor: 'black' 
			stroke: 'black' 
			strokeWidth: 0! !

!JASVGITagCircle class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 06:28'!
newAt: aPoint id: id r: radius fillColor: fillColor stroke: stroke strokeWidth: strokeWidth
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'cx' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'cy' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'r' value: radius);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: strokeWidth);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
center

	^(self x) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getBottomMiddlePoint

	^(self x) @ (self y + self height)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getLeftMiddlePoint

	^(self x - self width) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getRightMiddlePoint

	^(self x + self width) @ (self y)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 06:18'!
getTopMiddlePoint

	^(self x) @ (self y - self height)! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:58'!
height
	^(self getAttributeNamed: 'r') attributeValue! !

!JASVGITagCircle methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:26'!
svgTag

	^'circle'! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:58'!
width
	^(self getAttributeNamed: 'r') attributeValue! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:56'!
x
	^(self getAttributeNamed: 'cx') attributeValue! !

!JASVGITagCircle methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:56'!
y
	^(self getAttributeNamed: 'cy') attributeValue! !

JASVGITagFigure subclass: #JASVGITagEllipse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagEllipse class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 10:08'!
newAt: aPoint id: id rx: rx ry: ry fillColor: fillColor stroke: stroke strokeWidth: strokeWidth
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'cx' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'cy' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'rx' value: rx);
		add: (JASVGIAttribute parent: self name: 'ry' value: ry);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'strokeWidth' value: strokeWidth);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagEllipse methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 10:06'!
svgTag

	^'ellipse'! !

!JASVGITagFigure class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 04:38'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width')! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 09:28'!
addConnectorPoint: aJasvgiTagFigure
	"NOT Supported by the standart "

	^connectorPoints at: aJasvgiTagFigure id put: aJasvgiTagFigure! !

!JASVGITagFigure methodsFor: 'Accessing' stamp: 'BrunoBB 09/09/2016 04:38'!
connectorPoints
	^connectorPoints! !

!JASVGITagFigure methodsFor: 'Updating' stamp: 'BrunoBB 09/09/2016 04:38'!
connectorPoints: newValue
	connectorPoints := newValue! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:06'!
drawOn: aJASVGICanvas

	aJASVGICanvas 
		tag: self svgTag 
		attributes: self asSvgAttributes 
		with: [connectorPoints do: [:each | 
					aJASVGICanvas tag: each svgTag attributes: each asSvgAttributes]
		].! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getBottomMiddlePoint

	^((self x + (self width //2)) @ ((self y + self height)))! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getLeftMiddlePoint

	^((self x) @ ((self y + (self height//2))))! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 06:12'!
getPointToConnectTo: aJasvgiTagElement

	((self x + self width + 20) < aJasvgiTagElement x) ifTrue: [^self getRightMiddlePoint].

	((self y + self height + 20) < aJasvgiTagElement y) ifTrue: [^self getBottomMiddlePoint].

	((self x) > (aJasvgiTagElement x + aJasvgiTagElement width + 20)) ifTrue: [^self getLeftMiddlePoint].

	((self y) > (aJasvgiTagElement y + aJasvgiTagElement height + 20)) ifTrue: [^self getTopMiddlePoint].

	^(self x + self width//2) @ (self y + self height//2)! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getRightMiddlePoint

	^((self x + self width) @ ((self y + (self height//2))))! !

!JASVGITagFigure methodsFor: 'geometry' stamp: 'BrunoBB 09/10/2016 05:59'!
getTopMiddlePoint

	^((self x + (self width //2)) @ self y)! !

!JASVGITagFigure methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 04:39'!
initialize

	super initialize.

	connectorPoints := Dictionary new.! !

JASVGITagFigure subclass: #JASVGITagPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:35'!
newBottomId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '50%');
		add: (JASVGIAttribute parent: self name: 'y' value: '100%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:33'!
newLeftId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '0%');
		add: (JASVGIAttribute parent: self name: 'y' value: '50%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:33'!
newRightId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '100%');
		add: (JASVGIAttribute parent: self name: 'y' value: '50%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 05:32'!
newTopId: id markerId: markerId
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: '50%');
		add: (JASVGIAttribute parent: self name: 'y' value: '0%');
		add: (JASVGIAttribute parent: self name: 'marker' value: 'url(#',markerId,')');
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPoint methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 10:03'!
svgTag

	^'point'! !

JASVGITagFigure subclass: #JASVGITagRectangle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:12'!
newAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'height' value: height);
		add: (JASVGIAttribute parent: self name: 'width' value: width);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagRectangle class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:12'!
newRoundAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'rx' value: 10);
		add: (JASVGIAttribute parent: self name: 'ry' value: 10);
		add: (JASVGIAttribute parent: self name: 'fill' value: fillColor);
		add: (JASVGIAttribute parent: self name: 'height' value: height);
		add: (JASVGIAttribute parent: self name: 'width' value: width);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:43'!
getBottomLine

	^Array 
		with: ((self x + self height) @ self y)
		with: ((self x + self height) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:44'!
getLeftLine

	^Array 
		with: self position
		with: ((self x) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:45'!
getRightLine

	^Array 
		with: ((self x + self width) @ (self y))
		with: ((self x + self width) @ (self y + self height))! !

!JASVGITagRectangle methodsFor: 'geometry' stamp: 'BrunoBB 09/09/2016 09:37'!
getTopLine

	^Array 
		with: self position 
		with: ((self x + self width) @ self y)! !

!JASVGITagRectangle methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:26'!
svgTag

	^'rect'! !

JASVGITagElement subclass: #JASVGITagMarker
	instanceVariableNames: 'figure'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:56'!
newArrowAt: aPoint id: id width: width height: height
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'markerWidth' value: width);
		add: (JASVGIAttribute parent: self name: 'markerHeight' value: height);
		add: (JASVGIAttribute parent: self name: 'refX' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'refY' value: aPoint y);
		add: (JASVGIAttribute parent: self name: 'orient' value: 'auto');
		yourself.

	^super new initialize
		id: id;
		setAttributes: attributes;
		setBlackArrow;
		yourself! !

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:23'!
newCircleAt: aPoint id: id width: width height: height
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'markerWidth' value: width);
		add: (JASVGIAttribute parent: self name: 'markerHeight' value: height);
		add: (JASVGIAttribute parent: self name: 'refX' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'refY' value: aPoint y);
		yourself.

	^super new initialize
		id: id;
		setAttributes: attributes;
		setBlackCircle;
		yourself! !

!JASVGITagMarker class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:23'!
newCircleAt: aPoint width: width height: height

	^self newCircleAt: aPoint id: UUID new asString width: width height: height! !

!JASVGITagMarker methodsFor: 'draw' stamp: 'BrunoBB 09/07/2016 08:13'!
drawOn: aJASVGICanvas

	aJASVGICanvas 
		tag: self svgTag 
		attributes: self asSvgAttributes 
		with: [aJASVGICanvas tag: figure svgTag attributes: figure asSvgAttributes]! !

!JASVGITagMarker methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 15:39'!
figure
	^figure! !

!JASVGITagMarker methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 15:39'!
figure: newValue
	figure := newValue! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:51'!
setBlackArrow

	figure := JASVGITagPath newLine: 'M2,2 L2,11 L10,6 L2,2' id: 'arrow' widthPx: '1px' stroke: 'black' fillColor: 'black'! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:32'!
setBlackCircle

	figure := JASVGITagCircle newAsConnectorAt: 5@5! !

!JASVGITagMarker methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:27'!
svgTag

	^'marker'! !

JASVGITagElement subclass: #JASVGITagPath
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:46'!
newLine: pointsString id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| attributes colorString |

	colorString := fillColor ifNil: ['none'] ifNotNil: [fillColor].

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'd' value: pointsString);
		add: (JASVGIAttribute parent: self name: 'stroke-width' value: widthPx);
		add: (JASVGIAttribute parent: self name: 'stroke' value: stroke);
		add: (JASVGIAttribute parent: self name: 'fill' value: colorString);
		yourself.

	^self newId: id withAll: attributes! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 08:48'!
newLineM: points

	^self newLineM: points id: UUID new asString! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 08:48'!
newLineM: points id: id

	^self newLineM: points id: id widthPx: '1px'! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 08:48'!
newLineM: points id: id widthPx: width

	^self newLineM: points id: id widthPx: '1px' stroke: 'black' fillColor: nil! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/09/2016 10:47'!
newLineM: points id: id widthPx: widthPx stroke: stroke fillColor: fillColor 
	"Draw a Moveto line"
	| pointsString colorString |

	pointsString := PrintStream on: String new.
	colorString := fillColor ifNil: ['none'] ifNotNil: [fillColor].

	points do: [:eachPoint | pointsString nextPutAll: ('M',eachPoint x printString, ',', eachPoint y printString), ' '].

	^self newLine: pointsString contents id: id widthPx: widthPx stroke: stroke fillColor: fillColor! !

!JASVGITagPath class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 09:10'!
styleAttributesNames

	^#('fill' 'stroke' 'stroke-width' 'marker-start' 'marker-end')! !

!JASVGITagPath methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:27'!
svgTag

	^'path'! !

JASVGITagElement subclass: #JASVGITagText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JASVGI'!

!JASVGITagText class methodsFor: 'other' stamp: 'BrunoBB 09/07/2016 07:12'!
newText: aString at: aPoint id: id 
	| attributes |

	attributes := OrderedCollection new 
		add: (JASVGIAttribute parent: self name: 'x' value: aPoint x);
		add: (JASVGIAttribute parent: self name: 'y' value: aPoint y);
		yourself.

	^(JASVGITagText newId: id withAll: attributes) text: aString! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:29'!
drawOn: aJASVGICanvas

	aJASVGICanvas tag: self svgTag attributes: self asSvgAttributes with: text! !

!JASVGITagText methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 15:32'!
svgTag

	^'text'! !

!JASVGITagText methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 13:53'!
text
	^text! !

!JASVGITagText methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 13:53'!
text: newValue
	text := newValue! !
